% prepare active basis templates
clear all; close all
import feature.*
scale = .7; nGaborOri = 16;
[allfilter, allsymbol] = makefilter(scale, nGaborOri) ;
count = 1;
template_size = [120 120];

%% elipse (circle) (may append multiple scales)
row = [-36 -35 -31 -22 -10 0 10 22 31 35 36 35 31 22 10 0 -10 -22 -31 -35] + template_size(1)/2;
col = [0 10 22 31 35 36 35 31 22 10 0 -10 -22 -31 -35 -36 -35 -31 -22 -10] + template_size(2)/2;
ori = [0 15 13 11 9   8  7  5  3  1 0  15  13  11   9   8  7  5  3  1];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

row = floor(.5 + [-36 -35 -31 -22 -10 0 10 22 31 35 36 35 31 22 10 0 -10 -22 -31 -35] * .5 ) + template_size(1)/2;
col = [0 10 22 31 35 36 35 31 22 10 0 -10 -22 -31 -35 -36 -35 -31 -22 -10] + template_size(2)/2;
ori = [0 15 14 13 11 8  5  3  2  1 0 15 14 13 11 8  5  3  2  1];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% rectangle
row = [-36 -24 -12 0 12 24 36 40 40 40 40  40  40  40  36  24 12    0  -12  -24  -36 -40 -40 -40 -40 -40 -40 -40] + template_size(1)/2;
col = [40  40  40 40 40 40 40 36 24 12 0 -12 -24 -36 -40 -40 -40 -40 -40 -40 -40 -36 -24 -12 0 12 24 36] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 0 0 0 0 0 0 0 8 8 8 8 8 8 8 0 0 0 0 0 0 0 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


row = [-36 -24 -12 0 12 24 36 46 46 46 46  46  46  46  36  24 12    0  -12  -24  -36 -46 -46 -46 -46 -46 -46 -46] * .5 + template_size(1)/2;
col = [40  40  40 40 40 40 40 36 24 12 0 -12 -24 -36 -40 -40 -40 -40 -40 -40 -40 -36 -24 -12 0 12 24 36] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 0 0 0 0 0 0 0 8 8 8 8 8 8 8 0 0 0 0 0 0 0 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% line
row = [-36 -24 -12 0 12 24 36] + template_size(1)/2;
col = [0 0 0 0 0 0 0] + template_size(2)/2;
ori = [8 8 8 8 8 8 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% 1/2 elipse
row = [-36 -35 -31 -22 -10 0 10 22 31 35 36] + template_size(1)/2;
col = [0 10 22 31 35 36 35 31 22 10 0] + template_size(2)/2;
ori = [0 15 13 11 9   8  7  5  3  1 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

row = floor(.5 + [-36 -35 -31 -22 -10 0 10 22 31 35 36] * .5 ) + template_size(1)/2;
col = [0 10 22 31 35 36 35 31 22 10 0] + template_size(2)/2;
ori = [0 15 14 13 11 8  5  3  2  1 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% 1/4 elipse
row = [-36 -35 -31 -22 -10 0] + template_size(1)/2;
col = [0 10 22 31 35 36] + template_size(2)/2;
ori = [0 15 13 11 9 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

row = floor(.5 + [-36 -35 -31 -22 -10 0] * .5 ) + template_size(1)/2;
col = [0 10 22 31 35 38] + template_size(2)/2;
ori = [0 15 14 13 11 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


%% parallel line
row = [-36 -24 -12 0 12 24 36 -36 -24 -12 0 12 24 36] + template_size(1)/2;
col = [-8 -8 -8 -8 -8 -8 -8 8 8 8 8 8 8 8] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 8 8 8 8 8 8 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


%% angle
row = [-36 -24 -12 0 12 24 36 -36 -24 -12 0 12 24 36] + template_size(1)/2;
col = [-8 -5 -2 0 3 6 8 8 8 8 8 8 8 8] + template_size(2)/2;
ori = [9 9 9 9 9 9 8 8 8 8 8 8 8 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


row = [-12 -4 4 12 20 28 36 -36 -24 -12 0 12 24 36] + template_size(1)/2;
col = [-28 -20 -12 -4 4  12 20 24 24 24 24 24 24 24] + template_size(2)/2;
ori = [12 12 12 12 12 12 12 8 8 8 8 8 8 8];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


row = [-36 -24 -12 0 12 24 36 40 40 40 40  40  40  40] + template_size(1)/2;
col = [40  40  40 40 40 40 40 36 24 12 0 -12 -24 -36] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 0 0 0 0 0 0 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;


%% cross
row = [-36 -24 -12 0 12 24 36 0 0 0 0 0 0 0] + template_size(1)/2;
col = [0 0 0 0 0 0 0 -36 -24 -12 0 12 24 36] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 0 0 0 0 0 0 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% T-junction
row = [-36 -24 -12 0 12 24 36 -40 -40 -40 -40 -40 -40 -40] + template_size(1)/2;
col = [0 0 0 0 0 0 0 -36 -24 -12 0 12 24 36] + template_size(2)/2;
ori = [8 8 8 8 8 8 8 0 0 0 0 0 0 0];
T{count} = struct('selectedRow',single(row),...
    'selectedCol',single(col),...
    'selectedOri',single(ori),...
    'selectedScale',zeros(length(row),1,'single'));
count = count + 1;

%% display all templates
sym = cell(length(T),1);
for j = 1:length(T)
    sym{j} = double( util.displayGaborTemplate(template_size, T{j}.selectedRow, T{j}.selectedCol,...
        T{j}.selectedOri,...
        ones(length(T{j}.selectedRow),1),allsymbol) );
end
%im = displayImages(sym,5,80,80);
%figure; imshow(im,[]);

%% center all templates
for j = 1:length(T)
    minval = min(T{j}.selectedRow);
    maxval = max(T{j}.selectedRow);
    T{j}.selectedRow = T{j}.selectedRow - floor( .5 * ( minval + maxval ) );
    minval = min(T{j}.selectedCol);
    maxval = max(T{j}.selectedCol);
    T{j}.selectedCol = T{j}.selectedCol - floor( .5 * ( minval + maxval ) );
end

if ~exist('Feature','dir')
    mkdir('Feature');
end
save('Feature/shapelets.mat','sym','T');
