%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function featureConvolution_MSGabor(featureVersion,selected_categories,overwrite,windowSize,maxImArea)

import feature.*

Upperbound = feature.getGaborResponseUpperbound; % upperbound for Gabor response
norient = 16; % number of Gabor orientations
Lrange_ratio = .25; Orange = 1; % local deformation parameters

% all positive images are inscribed in a square lattice
allfilter = makefilter(0.35,norient);
tmp = makefilter(0.5,norient);
allfilter = [allfilter(:); tmp(:)];
tmp = makefilter(0.7,norient);
allfilter = [allfilter(:); tmp(:)];
tmp = makefilter(1,norient);
allfilter = [allfilter(:); tmp(:)];

%% positive example images
rescale = 1;

categories = selected_categories;
nCat = length(categories);
iRun = 1;
for iCat = 1:nCat
    load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),...
            'posTrainImages','posTestImages');
        
    if ~exist(sprintf('Feature/%s/%s',featureVersion,categories{iCat}),'dir')
        mkdir(sprintf('Feature/%s/%s',featureVersion,categories{iCat}));
    end

    imageNames = posTrainImages;
    n = length(imageNames);
    for i = 1:n
        imagePath = sprintf('Image/%s/%s',categories{iCat},imageNames{i});
        dumpFeature_MSGabor(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,...
			Lrange_ratio, Orange, Upperbound);
    end

    imageNames = posTestImages;
    n = length(imageNames);
    for i = 1:n
        imagePath = sprintf('Image/%s/%s',categories{iCat},imageNames{i});
        dumpFeature_MSGabor(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,...
			Lrange_ratio, Orange, Upperbound);
    end
end

%% natural images
%{
load('Split/Natural/split.mat','negTestImages','negTrainImages');
rescale = -1;

if ~exist(sprintf('Feature/%s/Natural',featureVersion),'dir')
    mkdir(sprintf('Feature/%s/Natural',featureVersion));
end

imageNames = negTestImages;
n = length(imageNames);
for i = 1:n
    imagePath = sprintf('Image/%s/%s','Natural',imageNames{i});
    % below: need to add a branch over feature versions
    dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
		Lrange, Orange, sub, Upperbound);
end

imageNames = negTrainImages;
n = length(imageNames);
for i = 1:n
    imagePath = sprintf('Image/%s/%s','Natural',imageNames{i});
    dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
		Lrange, Orange, sub, Upperbound);
end
%}
