% cannot do svm multiclass, because each template has different features

for iCat = 1:nCat
	if testOnlyOneCategory
		if iCat > 1
			break;
		end
	end
	iT = iCat;
	%% training
	disp(sprintf('learning from category : %s. Regularization constant = %d',categories{iCat},regularization_constant));
	if strcmp(LearningMethod(1:2),'lr') % logistic regression
		Y = 2 * (double(catNo == iCat) - .5);
		if strcmp(LearningMethod(end),'2')
			param_s = 0;
		else
			param_s = 6;
		end
		param_B = 1;
		param_c = regularization_constant;
		weight_of_pos = 1; %double(sum(y<0))/double(sum(y>0));
		param_e = 1e-2; % epsilon
		% -s 0 is for L2-logistic regression, -B 1 is for bias term, -c is for tuning parameter
		para=sprintf('-s %d -B %d -c %f -w1 %f -q -e %f',param_s,param_B,param_c,weight_of_pos,param_e); 

		% re-organize training data
		%	lrtrain uses the label of the first training example as the positive label (no matter its value is +1 or -1)
		%
		posind = find(Y>0); negind = find(Y<0);
		X{iT} = [X{iT}(posind,:);X{iT}(negind,:)]; Y = [Y(posind);Y(negind)];
		lr_model = lrtrain(Y,sparse(X{iT}),para);
		train_scores = [X{iT} ones(size(X{iT},1),1)] * lr_model.w(:);
		model_file = sprintf( 'Result/%s/%s/model_vs_all_%s_run%d.mat', categories{iCat}, modelName, LearningMethod, iRun );
		save( model_file, 'lr_model', 'param_s', 'param_B', 'param_c', 'param_e', 'weight_of_pos', 'para', 'train_scores', 'Y', 'regularization_constant' );
	
	elseif strcmp(LearningMethod,'svmlight-sc') % svm-light, single class

		Y = 2 * (double(catNo == iCat) - .5); % ground truth labels (-1 or 1)
		modelfile = sprintf('Result/model.txt');
		examplefile = sprintf('Result/exampletrain.txt');
		% output the training file
		fid = fopen(examplefile, 'w');
		for j = 1:length(Y)
		    fprintf(fid, '%d ', Y(j));
		    for k = 1:size(X{iT},2)
		        fprintf(fid, '%d:%.5f ', k, X{iT}(j,k));
		    end
		    fprintf(fid,'\r\n');
		end
		fclose(fid);
		
		para = '-v 0'; % use the default c parameter
		system( sprintf('./Code/svmlight/svm_learn %s %s %s',para,examplefile,modelfile) );
		
		% load svm model
		fid = fopen(modelfile, 'r');
		% read line 10: number of SV
		for line = 1:9
			tline = fgetl(fid);
		end
		nSV = fscanf(fid, '%d', 1) - 1; % line 10 
		tline = fgetl(fid);
		b = fscanf(fid, '%f', 1); % line 11
		tline = fgetl(fid); 
		D = size(X{iT},2);
		svm_model.w = zeros(1,D+1);
		svm_model.w(D+1) = b;

		% read line 12~end: SV's
		for jSV = 1:nSV
			% read alpha * y
			alpha = fscanf( fid, '%f', 1 );
			vec = zeros(1,D);
			for d = 1:D
				feaID = fscanf( fid, '%d', 1 );
				colon = fscanf( fid, '%c', 1 );
				feaVal = fscanf( fid, '%f', 1 );
				vec(d) = feaVal;
			end
			svm_model.w(1:D) = svm_model.w(1:D) + vec * alpha;
			tline = fgetl(fid);
		end

		train_scores = [X{iT} ones(size(X{iT},1),1)] * svm_model.w(:);

		model_file = sprintf( 'Result/%s/%s/model_vs_all_%s_run%d.mat', categories{iCat}, modelName, LearningMethod, iRun );
		save( model_file, 'svm_model', 'para', 'train_scores', 'Y' );
	end
end

