function evaluate_vs_all(LearningMethod,iRun,categories)

modelName = 'ActiveBasis';
nCat = length(categories);
testOnlyOneCategory = false;

for iT = 1:nCat
	if testOnlyOneCategory
		if iT > 1
			break;
		end
	end
		
	neg_score = [];
	for iCat = 1:nCat
		load(sprintf('Result/%s/%s/scores_vs_all_%s_run%d.mat',categories{iCat},modelName,LearningMethod,iRun),'scores');
		if iCat == iT
			pos_score = scores(:,iT);
		else
			neg_score = [neg_score; scores(:,iT)];
		end
	end
	
	gt = [ones(length(pos_score),1);-1*ones(length(neg_score),1)];
	predicted = [pos_score;neg_score];
	[ap_vs_all prec_vs_all rec_vs_all] = evaluation.getAP(gt,predicted);
	[auc_vs_all tp_vs_all fp_vs_all] = evaluation.getAUC(gt,predicted);
	
	out_file = sprintf('Result/%s/%s/scores_vs_all_%s_run%d.mat',categories{iT},modelName,LearningMethod,iRun);
	
	save(out_file,'gt','predicted','ap_vs_all','prec_vs_all','rec_vs_all','auc_vs_all','tp_vs_all','fp_vs_all','-append');
	
	collected_ap_vs_all(iT) = ap_vs_all;
	collected_auc_vs_all(iT) = auc_vs_all;
	
end

for iCat = 1:nCat
	if testOnlyOneCategory
		if iCat > 1
			break;
		end
	end
	load(sprintf('Result/%s/%s/scores_vs_all_%s_run%d.mat',categories{iCat},modelName,LearningMethod,iRun),'scores');
	[val maxind] = max(scores,[],2);
	recognition_rate = sum(maxind == iCat) / length(maxind);
	out_file = sprintf('Result/%s/%s/scores_vs_all_%s_run%d.mat',categories{iCat},modelName,LearningMethod,iRun);
	save(out_file,'recognition_rate','-append');
	collected_recognition_rate(iCat) = recognition_rate;
end

folder = sprintf('Result/%s/%s','summary',modelName);
if ~exist(folder,'dir')
	mkdir(folder);
end

out_file = sprintf('Result/%s/%s/result_vs_all_%s_run%d.mat','summary',modelName,LearningMethod,iRun);
if exist(out_file,'file')
	save(out_file,'collected_ap_vs_all','collected_auc_vs_all','collected_recognition_rate','-append');
else
	save(out_file,'collected_ap_vs_all','collected_auc_vs_all','collected_recognition_rate');
end


