%{
HIT_color = struct('var',[],'meanHist',[],...
    'inhibited',[],'varMap',[],'selectedx',[],'selectedy',[]...
    , 'radius',5,'gain',[],'commonTemplate',[], 'subsample', 3, 'colorHistVersion', 0 );
%}

hsvLearn = cell(nimage,3);
colorHistVersion = 0; % 0: simply local mean of H,S,V channels (3 dimensional vector per location)
					  % 1: 16,4,4 bins for H,S,V channels (24 dimensional vector per location)

ax = 4; % radius of local color histogram pooling
nF = 50;
gain_thres = .01;

imageSet = 'Train/pos';
for i = 1:nimage
	featurePath = sprintf('Feature/%s/%s/%05d.mat','HoG',imageSet,i);
    load(featurePath,'patch');
	if size(patch,3) == 1
		patch = repmat(patch,[1 1 3]);
	end
	if size(patch,3) == 1
		disp('error!');
		keyboard;
	end
	hsv = rgb2hsv( patch );
	hsv(:,:,3) = hsv(:,:,3) / 255;
	%hHist = imhist( hsv(:,:,1), 16 );
	%sHist = imhist( hsv(:,:,2), 4 );
	%vHist = imhist( hsv(:,:,3), 4 );
	%hsvHist = [hHist(:)',sHist(:)',vHist(:)'];
	for c = 1:3
		hsvLearn{i,c} = single( hsv(:,:,c) );
	end
end

% compute map of histogram feature
subsample_color = min( 4, floor(ax/2) );
if colorHistVersion == 0
	varMap = 10 * ones(size(hsvLearn{1}),'single');
	hI = cell(size(hsvLearn,1),size(hsvLearn,2));
	for i = 1:size(hI,1)
		for j = 1:size(hI,2)
			hI{i,j} = zeros(size(hsvLearn{1,1}),'single');
		end
	end
	% the following function is used to compute orientation histogram, but it can also be applied for computing local color histograms
	model.HIT.CGraHist(nimage,3,hsvLearn,hI,varMap,size(hsvLearn{1},1),size(hsvLearn{1},2),ax,ax,0,subsample_color); 
elseif colorHistVersion == 1
	[hI varMap] = model.HIT.mexc_HSV24(hsvLearn,ax,subsample_color);
end
varMapSaved = varMap;

% pursue the least-variance positions
nBin = size(hI,2);
sx = size(varMap,1); sy = size(varMap,2);
inhibited = zeros(sx,sy);
selectedMeanHist = zeros(nF,nBin);
maxValue = max(varMap(:));
minVar = zeros(nF,1);
Mx = zeros(nF,1); My = zeros(nF,1);

for k = 1:nF
    [minVar(k) ind] = min(varMap(:));
    
    col = ceil(ind/sx); My(k) = col;
    row = ind - (col-1)*sx; Mx(k) = row;
    % calculate the mean gradient histogram
    hists = zeros(nimage,nBin);
    for b = 1:nBin
        for j = 1:nimage
            hists(j,b) = hI{j,b}(row,col);
        end
    end
    selectedMeanHist(k,:) = sum(hists,1)/nimage;
    
    if -1/2-log( sqrt(2*pi.*minVar(k)) ) < gain_thres || minVar(k) > maxValue
        nF = k-1;
        break;
    end
    
    % do inhibition
    left = max(1,col-ay);
    right = min(sy,col+ay);
    top = max(1,row-ax);
    bottom = min(sx,row+ax);
    inhibited(top:bottom,left:right) = 1;
    varMap(top:bottom,left:right) = maxValue + 1;
end
minVar = minVar(1:nF); Mx = Mx(1:nF); My = My(1:nF); selectedMeanHist = selectedMeanHist(1:nF,:); 
gain = -1/2-log(sqrt(2*pi.*minVar));

HIT_color = struct('var',single(minVar),'meanHist',single(selectedMeanHist),...
    'inhibited',inhibited,'varMap',varMapSaved,'selectedx',single(Mx),'selectedy',single(My)...
    , 'radius',ax,'gain',gain,'commonTemplate',[], 'subsample', subsample_color, 'colorHistVersion', colorHistVersion );
   
%}
