
S1Learn = storedS1Learn;
M1Learn = storedM1Learn;
maxNumFeature = 100;
ax = 4;
sx = size(S1Learn{1},1); sy = size(S1Learn{1},2);
gain_thres = 0.01;

localAveFilter = ones(ax*2+1,ax*2+1,'single')/single(ax*2+1)/single(ax*2+1);
S1LocalMeanOverOrientation = cell(nimage,1);
for i = 1:nimage
	S1LocalMean = cell(1,norient);
	for o = 1:norient
		S1LocalMean{o} = M1Learn{i,o};
		%S1LocalMean{o} = filter2(localAveFilter,S1Learn{i,o},'same');
	end
	S1LocalMeanOverOrientation{i} = zeros(sx,sy);
	for o = 1:norient
		S1LocalMeanOverOrientation{i} = S1LocalMeanOverOrientation{i} + 1/norient * S1LocalMean{o};
    end
    S1LocalMeanOverOrientation{i} = Upperbound - S1LocalMeanOverOrientation{i};
end

% compute the map of information gain
inhibited = zeros(sx,sy);
templateSize = [sx sy];

meanLocalFlatMap = zeros(sx, sy);
for i = 1:nimage
	meanLocalFlatMap(:,:) = meanLocalFlatMap(:,:) + 1/nimage * S1LocalMeanOverOrientation{i};
end

Mx = zeros(1, maxNumFeature);  % position of selected Gabor
My = zeros(1, maxNumFeature); 
Mm = zeros(1, maxNumFeature);  % mean
lambda = zeros(1, maxNumFeature);  % lambda
logZ = zeros(1, maxNumFeature);  % logZ
gain = zeros(maxNumFeature, 1);  % coding gain for selected Gabor

gainMap = meanLocalFlatMap;
gainMap([1:15 templateSize(1)-15+1:end],:) = 0;
gainMap(:,[1:15 templateSize(1)-15+1:end]) = 0;

% pursuit the largest-gain positions

nF = maxNumFeature;
for k = 1:nF
	[maxGain here] = max(gainMap(:) .* double(1-inhibited(:))  );
	if maxGain <= gain_thres
		nF = k-1;
		break
	end

	col = ceil(here/templateSize(1));
	My(k) = col;
	row = here - (col-1)*templateSize(1); 
	Mx(k) = row;
	
	gain(k) = maxGain;
	
	% do inhibition
	left = max(1,col-ax);
	right = min(templateSize(2),col+ax);
	top = max(1,row-ax);
	bottom = min(templateSize(1),row+ax);
    inhibited(top:bottom,left:right) = 1;
    gainMap(top:bottom,left:right) = 0;
    % disp(sprintf('%d %d %.3f %.3f',Mx(k),My(k),Mm(k),gain(k)));
end
Mm = Mm(1:nF); Mx = Mx(1:nF); My = My(1:nF);
gain = gain(1:nF); % this gain is fake

% save results

HIT_flatness = struct(...
    'inhibited',inhibited,'selectedx',single(Mx),'selectedy',single(My)...
    ,'radius',ax,'gain',gain,'Mm',Mm,...
    'meanLocalFlatMap', meanLocalFlatMap,...
    'Upperbound',Upperbound);








