
S1Learn = cell(nimage,nOri);
storedS1Learn = cell(nimage,nOri);
M1Learn = cell(nimage,nOri);
storedM1Learn = cell(nimage,nOri);
ARGMAX1Learn = cell(nimage,nOri);
for i = 1:nimage
	featurePath = sprintf('Feature/%s/%s/%05d.mat',featureVersion,imageSet,i);
	load(featurePath,...
        'S1LocalNorm','M1LocalNorm','ARGMAX1LocalNorm','M1RowShift','M1ColShift','M1OriShifted','RANGE');
    S1LocalNorm = feature.convert2float(S1LocalNorm,RANGE);
    feature.mexc_Sigmoid(Upperbound,S1LocalNorm);
    M1LocalNorm = feature.convert2float(M1LocalNorm,RANGE);
    feature.mexc_Sigmoid(Upperbound,M1LocalNorm);
	
	% inscribe if needed
	if size(M1LocalNorm{1},1) ~= windowSize(1) || size(M1LocalNorm{1},2) ~= windowSize(2)
		for o = 1:nOri
			M1LocalNorm{o} = single( util.inscribe( windowSize, M1LocalNorm{o}, 0 ) );
			S1LocalNorm{o} = single( util.inscribe( windowSize, S1LocalNorm{o}, 0 ) );
			ARGMAX1LocalNorm{o} = int32( util.inscribe( windowSize, ARGMAX1LocalNorm{o}, 0 ) );
		end
	end

	S1Learn(i,:) = S1LocalNorm(:);
    for o = 1:nOri
        storedS1Learn{i,o} = S1LocalNorm{o} + 0.;
		storedM1Learn{i,o} = M1LocalNorm{o} + 0.;
    end
	M1Learn(i,:) = M1LocalNorm(:);
	ARGMAX1Learn(i,:) = ARGMAX1LocalNorm(:);
end


selectedx = zeros(numElement,1);
selectedy = zeros(numElement,1);
selectedOrient = zeros(numElement,1);
selectedLambda = zeros(numElement,1);
selectedLogZ = zeros(numElement,1);
commonTemplate = zeros(windowSize,'single');
deformedTemplate = cell(nimage,1);
for i = 1:nimage
	deformedTemplate{i} = zeros(windowSize,'single');
end

model.ActiveBasis.mexc_SharedSketch(nOri, Lrange, Orange, subsample, numElement ... % about active basis  
	, nimage, windowSize(1), windowSize(2), ...
	S1Learn, M1Learn, ARGMAX1Learn, ... % about training images 
	halfFilterSize, Correlation, allSymbol(1, :), ... % about filters
	numStoredPoint, lam, e, lz, ... % about exponential model 
	selectedOrient, selectedx, selectedy, selectedLambda, selectedLogZ, ... % learned parameters
	commonTemplate, deformedTemplate,... % learned templates 
	M1RowShift, M1ColShift, M1OriShifted); % stored local shifts

HIT_sketch = struct( 'commonTemplate', single(commonTemplate), 'selectedx', single(selectedx),...
	'selectedy', single(selectedy), 'selectedOrient', single(selectedOrient),...
	'selectedLambda', single(selectedLambda), 'selectedLogZ', single(selectedLogZ) );
