
gain_thres = 0.001;
nF = 200; % maximum number of selected features
ax = 4; % radius for pooling local orientation histograms
ay = ax;
Upperbound_tex = Upperbound;

S1Learn_tex = cell(nimage,nOri);

for i = 1:nimage
	featurePath = sprintf('Feature/%s/%s/%05d.mat',featureVersion,imageSet,i);
	load(featurePath,...
        'S1LocalNorm','RANGE');
    S1 = feature.convert2float(S1LocalNorm,RANGE);
    feature.mexc_Sigmoid(Upperbound_tex,S1);
	
	% inscribe if needed
	if size(S1{1},1) ~= windowSize(1) || size(S1{1},2) ~= windowSize(2)
		for o = 1:nOri
			S1{o} = single( util.inscribe( windowSize, S1, 0 ) );
		end
	end

	S1Learn_tex(i,:) = S1(:);
end
varMap = 2*ones(size(S1Learn_tex{1}),'single');

% compute map of orientation histogram
% halfFilterSize = 8;
subsample_tex = min(floor(ax/2),floor(halfFilterSize/2));
hI = cell(size(S1Learn_tex,1),size(S1Learn_tex,2));
for i = 1:size(hI,1)
    for j = 1:size(hI,2)
        hI{i,j} = zeros(size(S1Learn_tex{1,1}),'single');
    end
end

model.HIT.CGraHist(nimage,nOri,S1Learn_tex,hI,varMap,size(S1Learn_tex{1},1),size(S1Learn_tex{1},2),ax,ax,halfFilterSize,subsample_tex);
varMapSaved = varMap;

% pursue the least-variance positions
sx = size(varMap,1); sy = size(varMap,2);
inhibited = zeros(sx,sy);
selectedMeanHist = zeros(nF,norient);
maxValue = max(varMap(:));
minVar = zeros(nF,1);
Mx = zeros(nF,1); My = zeros(nF,1);

for k = 1:nF
    [minVar(k) ind] = min(varMap(:));
    
    col = ceil(ind/sx); My(k) = col;
    row = ind - (col-1)*sx; Mx(k) = row;
    % calculate the mean gradient histogram
    hists = zeros(nimage,norient);
    for o = 1:norient
        for j = 1:nimage
            hists(j,o) = hI{j,o}(row,col);
        end
    end
    selectedMeanHist(k,:) = sum(hists,1)/nimage;
    
    if -1/2-log( sqrt(2*pi.*minVar(k)) ) < gain_thres || minVar(k) > maxValue
        nF = k-1;
        break;
    end
    
    % do inhibition
    left = max(1,col-ay);
    right = min(sy,col+ay);
    top = max(1,row-ax);
    bottom = min(sx,row+ax);
    inhibited(top:bottom,left:right) = 1;
    varMap(top:bottom,left:right) = maxValue + 1;
end
minVar = minVar(1:nF); Mx = Mx(1:nF); My = My(1:nF); selectedMeanHist = selectedMeanHist(1:nF,:); 
gain = -1/2-log(sqrt(2*pi.*minVar));

texSym = zeros(sx,sy);
h = halfFilterSize;
for iF = 1:length(gain)
    vec = selectedMeanHist(iF,:);
    vec = vec.^4 + 1e-10;
    vec = vec/sum(vec);
    
    small_symbol = zeros( h*2+1, h*2+1 );
    for ori = 1:norient
    	small_symbol = small_symbol + vec(ori) * allSymbol{ori};
    end
    
    paved_symbol = zeros( size(small_symbol)*2 + 1 );
    paved_symbol(1:2*h+1,1:2*h+1) = small_symbol;
    paved_symbol(2*h+1+(1:2*h+1),1:2*h+1) = small_symbol;
    paved_symbol(1:2*h+1,2*h+1+(1:2*h+1)) = small_symbol;
    paved_symbol(2*h+1+(1:2*h+1),2*h+1+(1:2*h+1)) = small_symbol;
    paved_symbol = imresize(paved_symbol,[ax+2*h+1 ax+2*h+1]);
    row_ind = ( Mx(iF) - floor(size(paved_symbol,1)/2) -1 ) + (1:size(paved_symbol,1));
    col_ind = ( My(iF) - floor(size(paved_symbol,2)/2) -1 ) + (1:size(paved_symbol,2));
    texSym(row_ind,col_ind) = ...
        max(texSym(row_ind,col_ind) ...
        , paved_symbol );

    
end


HIT_texture = struct('var',single(minVar),'meanHist',single(selectedMeanHist),...
    'inhibited',inhibited,'varMap',varMapSaved,'selectedx',single(Mx-0),'selectedy',single(My-0)...
    , 'radius',ax,'gain',gain,'commonTemplate',texSym, 'subsample', subsample_tex,...
    'halfFilterSize', halfFilterSize, 'Upperbound', Upperbound_tex);




