clear;
re_compute_feature = true;

warning off all

cd('Code/+feature')
mex mexc_ComputeSUM2.cpp
mex mexc_ComputeMAX1.cpp
mex mexc_Histogram.cpp
mex mexc_Sigmoid.cpp
mex mexc_ComputeHoG.cpp
mex mexc_LocalNormalize.cpp
cd ../..
cd('Code/+model/+HIT');
mex CGraHist.c
mex mexc_ExtractFeatureVec.cpp
cd ../../..

addpath Code/liblinear/matlab
addpath Code/svmlight

displayModeIsOn = false;

if re_compute_feature
    % ! please comment the following lines to avoid duplicate computation
    feature.featureConvolution('HoG');
    feature.featureConvolution('GaborS1');
	
    feature.BackgroundStat_GaborS1; % Compute background statistics. This is needed for learning.
end


% ==========================================================
%
% cross validation experiments
%

model.HoGSimple.learn('libsvm'); % learning with svm
model.HoGSimple.test('libsvm'); % test with svm
model.HoGSimple.evaluate('libsvm'); % evaluation

model.HIT.learn('lrl2'); % learning with logistic regression with L2 regularization
model.HIT.test('lrl2'); % test with logistic regression with L2 regularization
model.HIT.evaluate('lrl2'); % evaluation

